pipeline {
    agent {
        kubernetes {
            label 'reem-agent'
            yamlFile 'agent.yaml'
            defaultContainer 'reem-agent'
        }
    }

    environment {
        DOCKER_REGISTRY = 'https://registry.hub.docker.com'
        DOCKER_HUB_CREDENTIALS = credentials('dockerhub-reem')
        GITLAB_TOKEN = credentials('gitlab-reem')
    }

    stages {
        stage('Test Docker') {
            steps {
                script {
                    sh 'docker --version'
                }
            }
        }

        stage('Build Docker Image') {
            steps {
                script {
                    try {
                        echo 'Starting Docker build...'
                        
                        // Clone the Git repository into the workspace
                        git branch: 'main', credentialsId: 'gitlab-reem', url: 'https://gitlab.com/sela-tracks/1095/students/reem/applications/profile.git'
                        
                        // Build the Docker image from the current directory
                        def dockerImage = docker.build('reemyitzhaki/my-flask-app:latest', '.')
                        echo 'Docker build completed.'
                    } catch (Exception e) {
                        // Print detailed error information
                        echo "Error: ${e.message}"
                        currentBuild.result = 'FAILURE'
                        error("Docker build failed")
                    }
                }
            }
        }

       
        

         

        stage('Push Docker Image') {
            steps {
                script {
                    echo 'Starting Docker push...'

                    // Log in to Docker Hub using credentials
                    withCredentials([usernamePassword(credentialsId: 'dockerhub-reem', usernameVariable: 'USERNAME', passwordVariable: 'PASSWORD')]) {
                        sh '''
                        echo "$PASSWORD" | docker login -u "$USERNAME" --password-stdin
                        docker push reemyitzhaki/my-flask-app:latest
                        '''
                    }

                    echo 'Docker push completed.'
                }
            }
        }
        
    }

    post {
        success {
            echo 'Docker image and Helm chart pushed successfully.'
        }
    }
}
